/*
								+---------------------------------+
								|                                 |
								|  ***   Lame common dlgs   ***  |
								|                                 |
								|  Copyright   -tHE SWINe- 2005  |
								|                                 |
								|            Dialogs.h            |
								|                                 |
								+---------------------------------+
*/

#ifndef __LAME_COMDLGS_INCLUDED
#define __LAME_COMDLGS_INCLUDED

#ifndef __UBERLAME_DLL
#define __declspec(x) 
// in case we're not compiling dll, we don't want to export anything
#endif

class __declspec(dllexport) CLameDialog {
protected:
	static std::vector<CLameDialog*> *m_p_dialog_list;
	static CLameDialog *m_p_recent_dialog;
	static CLameDialog *m_p_dialog_being_created;

	HWND m_h_dlg;
	int m_n_resource_id;

	int m_b_being_destroyed; // some glitches with messages sent after EndDialog()

public:
	CLameDialog(int n_resource_id);
	~CLameDialog();

	int Create(HWND h_parent, HINSTANCE h_instance); // can use GetModuleHandle(NULL); to obtain h_instance
	int End();

	void SetFocus() { if(b_Created()) ::SetFocus(m_h_dlg); }

	int b_Created();

protected:
	static int CALLBACK GlobalDlgProc(HWND h_dlg, unsigned int n_msg,
		unsigned int n_w_param, long n_l_param);
	virtual int DlgProc(HWND h_dlg, unsigned int n_msg,
		unsigned int n_w_param, long n_l_param) = 0;
};

class __declspec(dllexport) CLoggerDialog : public CLameDialog {
protected:
	int m_n_max_lines;

public:
	CLoggerDialog() :CLameDialog(IDD_LOGWINDOW), m_n_max_lines(256) {}

	void Set_MaxLines(int n_max_lines) { m_n_max_lines = n_max_lines; }

	int AddLine(const char *p_s_str);
	int AddLineF(const char *p_s_format_str, ...);

protected:
	virtual int DlgProc(HWND h_dlg, unsigned int n_msg,
		unsigned int n_w_param, long n_l_param);
};

/*class __declspec(dllexport) CRenderPathDialog : public CLameDialog {
protected:
	int m_b_clicked_ok;
	HWND m_h_listbox;

public:
	CRenderPathDialog() :CLameDialog(IDD_PATH_PICKER) {}

	int AddPath(const char *p_s_name, int n_supported_materials, int n_materials);
	int SelectPath(const char *p_s_name);
	int ShaderLang(int n_lang_switch, int b_arb_support, int b_glsl_support);
	int CompressTextures(int b_compress_textures);

	int Create(HWND h_parent, HINSTANCE h_instance);

	int DoModal(int &r_n_chosen_path, int &r_b_set_default,
		int &r_n_lang_switch, int &r_b_compress_textures);

protected:
	virtual int DlgProc(HWND h_dlg, unsigned int n_msg,
		unsigned int n_w_param, long n_l_param);
};*/

#endif //__LAME_COMDLGS_INCLUDED
